SystemOrganization addCategory: #'Magritte-Tests-Description'!
SystemOrganization addCategory: #'Magritte-Tests-Accessor'!
SystemOrganization addCategory: #'Magritte-Tests-Comparator'!
SystemOrganization addCategory: #'Magritte-Tests-Utility'!

TestCase subclass: #MAAccessorTest
	instanceVariableNames: 'description accessor value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

!MAAccessorTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 21:38'!
isAbstract
	^true! !

!MAAccessorTest class methodsFor: 'testing' stamp: 'lr 3/27/2005 10:05'!
shouldInheritSelectors
	^true! !

!MAAccessorTest methodsFor: 'accessing' stamp: 'lr 3/30/2005 21:04'!
accessor
	^accessor! !

!MAAccessorTest methodsFor: 'private' stamp: 'lr 4/7/2005 21:47'!
accessorInstance
	self subclassResponsability.! !

!MAAccessorTest methodsFor: 'private' stamp: 'lr 4/7/2005 22:52'!
defaultElement
	^ 'abc'! !

!MAAccessorTest methodsFor: 'accessing' stamp: 'lr 3/30/2005 21:04'!
description
	^description! !

!MAAccessorTest methodsFor: 'private' stamp: 'lr 4/7/2005 22:53'!
descriptionInstance
	^MAStringDescription new
		default: self defaultElement;
		yourself.! !

!MAAccessorTest methodsFor: 'private' stamp: 'lr 4/7/2005 22:54'!
includedElement
	^ 'xyz'! !

!MAAccessorTest methodsFor: 'private' stamp: 'lr 4/7/2005 22:54'!
invalidElement
	^ 123! !

!MAAccessorTest methodsFor: 'private' stamp: 'lr 4/7/2005 22:54'!
nullElement
	^ nil! !

!MAAccessorTest methodsFor: 'running' stamp: 'lr 3/30/2005 21:20'!
setUp
	description := self descriptionInstance.
	description accessor: (accessor := self accessorInstance).! !

!MAAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:33'!
testCopy
	self assert: self accessor copy description isNil.! !

!MAAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:41'!
testDescription
	self assert: self description accessor = self accessor.
	self assert: self accessor description = self description.! !

!MAAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:27'!
testRead
	self subclassResponsibility.! !

!MAAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:27'!
testWrite
	self subclassResponsibility.! !

!MAAccessorTest methodsFor: 'accessing-model' stamp: 'lr 3/30/2005 21:30'!
value
	^value! !

!MAAccessorTest methodsFor: 'accessing-model' stamp: 'lr 3/30/2005 21:30'!
value: anObject
	value := anObject! !

MAAccessorTest subclass: #MAModelAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

MAModelAccessorTest subclass: #MABlockAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

!MABlockAccessorTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 21:39'!
isAbstract
	^false! !

!MABlockAccessorTest methodsFor: 'private' stamp: 'lr 3/30/2005 21:41'!
accessorInstance
	^MABlockAccessor
		read: [ :model | model value ]
		write: [ :model :object | model value: object ].! !

!MABlockAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:44'!
testRead
	self value: 123.
	self assert: (self accessor read: self) = 123.
	
	self value: '12'.
	self assert: (self accessor read: self) = '12'.
! !

!MABlockAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:52'!
testReadBlock
	self accessor readBlock: [ :model |
		self assert: model = self. 123 ].
	self assert: (self accessor read: self) = 123.! !

!MABlockAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:44'!
testWrite
	self accessor write: 123 to: self.
	self assert: self value = 123.
	
	self accessor write: '123' to: self.
	self assert: self value = '123'.
! !

!MABlockAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:51'!
testWriteBlock
	self accessor writeBlock: [ :model :object |
		self assert: model = self.
		self assert: object = 123 ].
	self accessor write: 123 to: self.! !

MAModelAccessorTest subclass: #MACascadeAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

!MACascadeAccessorTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 21:48'!
isAbstract
	^false! !

!MACascadeAccessorTest methodsFor: 'private' stamp: 'lr 4/5/2005 20:51'!
accessorInstance
	^MACascadeAccessor selectors: #( holder contents value ).! !

!MACascadeAccessorTest methodsFor: 'private' stamp: 'lr 4/5/2005 20:52'!
holder
	^ValueHolder new 
		contents: self;
		yourself.! !

!MACascadeAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:12'!
testCopy
	super testCopy.
	self assert: self accessor copy next description isNil.
	self assert: self accessor copy accessor description isNil.! !

!MACascadeAccessorTest methodsFor: 'testing' stamp: 'lr 4/5/2005 20:58'!
testKind
	self assert: (self accessor isKindOf: MACascadeAccessor).
	self assert: (self accessor accessor isKindOf: MASelectorAccessor).
	self assert: (self accessor next isKindOf: MACascadeAccessor).
	self assert: (self accessor next accessor isKindOf: MASelectorAccessor).
	self assert: (self accessor next next isKindOf: MASelectorAccessor).! !

!MACascadeAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:06'!
testRead
	self value: 123.
	self assert: (self accessor read: self) = 123.
	
	self value: '12'.
	self assert: (self accessor read: self) = '12'.! !

!MACascadeAccessorTest methodsFor: 'testing' stamp: 'lr 4/5/2005 21:00'!
testSelector
	self assert: self accessor accessor selector = #holder.
	self assert: self accessor next accessor selector = #contents.
	self assert: self accessor next next selector = #value.! !

!MACascadeAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:07'!
testWrite
	self accessor write: 123 to: self.
	self assert: self value = 123.
	
	self accessor write: '123' to: self.
	self assert: self value = '123'.
! !

MAModelAccessorTest subclass: #MAContainerAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

!MAContainerAccessorTest class methodsFor: 'testing' stamp: 'lr 4/5/2005 21:02'!
isAbstract
	^false! !

!MAContainerAccessorTest methodsFor: 'private' stamp: 'lr 4/5/2005 21:02'!
accessorInstance
	^MAContainerAccessor new.! !

!MAContainerAccessorTest methodsFor: 'testing' stamp: 'lr 4/7/2005 23:17'!
testContainer
	self assert: self accessor isContainer.! !

!MAContainerAccessorTest methodsFor: 'testing' stamp: 'lr 4/5/2005 21:04'!
testRead
	self assert: (self accessor read: 123) = 123.! !

!MAContainerAccessorTest methodsFor: 'testing' stamp: 'lr 4/5/2005 21:04'!
testWrite
	self 	
		should: [ self accessor write: 123 to: self ] 
		raise: Error.
	self assert: self value isNil.! !

!MAModelAccessorTest methodsFor: 'testing' stamp: 'lr 4/7/2005 23:18'!
testContainer
	self deny: self accessor isContainer.! !

!MAModelAccessorTest methodsFor: 'testing' stamp: 'lr 4/7/2005 23:18'!
testNull
	self deny: self accessor isNull.! !

MAModelAccessorTest subclass: #MANullAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

!MANullAccessorTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 21:48'!
isAbstract
	^false! !

!MANullAccessorTest methodsFor: 'private' stamp: 'lr 4/5/2005 20:48'!
accessorInstance
	^MANullAccessor new.! !

!MANullAccessorTest methodsFor: 'testing' stamp: 'lr 4/7/2005 23:18'!
testNull
	self assert: self accessor isNull.! !

!MANullAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:20'!
testRead
	self 
		should: [ self accessor read: self ]
		raise: Error.! !

!MANullAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 22:20'!
testWrite
	self 	
		should: [ self accessor write: 123 to: self ] 
		raise: Error.
	self assert: self value isNil.! !

MAModelAccessorTest subclass: #MASelectorAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

!MASelectorAccessorTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 21:47'!
isAbstract
	^false! !

!MASelectorAccessorTest methodsFor: 'private' stamp: 'lr 3/30/2005 21:46'!
accessorInstance
	^MASelectorAccessor selector: #value.! !

!MASelectorAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:56'!
testRead
	self value: 123.
	self assert: (self accessor read: self) = 123.
	
	self value: '12'.
	self assert: (self accessor read: self) = '12'.! !

!MASelectorAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:55'!
testReadSelector
	self accessor readSelector: #contents.
	
	self assert: self accessor selector = #contents.
	self assert: self accessor readSelector = #contents.
	self assert: self accessor writeSelector = #value:.! !

!MASelectorAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:55'!
testSelector
	self accessor selector: #contents.
	
	self assert: self accessor selector = #contents.
	self assert: self accessor readSelector = #contents.
	self assert: self accessor writeSelector = #contents:.! !

!MASelectorAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:56'!
testWrite
	self accessor write: 123 to: self.
	self assert: self value = 123.
	
	self accessor write: '123' to: self.
	self assert: self value = '123'.
! !

!MASelectorAccessorTest methodsFor: 'testing' stamp: 'lr 3/30/2005 21:55'!
testWriteSelector
	self accessor writeSelector: #contents:.
	
	self assert: self accessor selector = #value.
	self assert: self accessor readSelector = #value.
	self assert: self accessor writeSelector = #contents:.! !

MAAccessorTest subclass: #MAModelWrapperTest
	instanceVariableNames: 'wrapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

MAModelWrapperTest subclass: #MACachedWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

!MACachedWrapperTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:25'!
isAbstract
	^false! !

!MACachedWrapperTest methodsFor: 'testing' stamp: 'lr 4/7/2005 23:10'!
testCommit
	self wrapper value: self includedElement.
	self assert: self wrapper hasChanged.
	
	self wrapper commit.
	self assert: self wrapper value = self includedElement.
	self assert: self value = self includedElement.
	self deny: self wrapper hasChanged.! !

!MACachedWrapperTest methodsFor: 'testing' stamp: 'lr 4/7/2005 22:55'!
testDefault
	self value: nil.
	self description default: self defaultElement. 
	
	self wrapper reset.
	self assert: self wrapper value = self defaultElement.
	self assert: self value isNil.
	
	self wrapper commit.
	self assert: self wrapper value = self defaultElement.
	self assert: self value = self defaultElement.
	
	self wrapper value: self includedElement; commit.
	self assert: self wrapper value = self includedElement.
	self assert: self value = self includedElement.! !

!MACachedWrapperTest methodsFor: 'testing' stamp: 'lr 4/7/2005 22:56'!
testRead
	self assert: self value = self nullElement.
	self assert: self wrapper value = self defaultElement.
	
	self value: self includedElement.
	self assert: self value = self includedElement.
	self assert: self wrapper value = self defaultElement.! !

!MACachedWrapperTest methodsFor: 'testing' stamp: 'lr 4/7/2005 23:10'!
testReset
	self value: self defaultElement.
	self wrapper value: self includedElement.
	self assert: self wrapper hasChanged.
	
	self wrapper reset.
	self assert: self wrapper value = self defaultElement.
	self assert: self value = self defaultElement.
	self deny: self wrapper hasChanged.! !

!MACachedWrapperTest methodsFor: 'testing' stamp: 'lr 4/7/2005 22:57'!
testWrite
	self value: self defaultElement.
	self wrapper value: self includedElement.
	self assert: self value = self defaultElement.
	self assert: self wrapper value = self includedElement.! !

!MACachedWrapperTest methodsFor: 'private' stamp: 'lr 3/30/2005 22:24'!
wrapperInstance
	^MACachedWrapper on: self description model: self.! !

MACachedWrapperTest subclass: #MACheckedWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

!MACheckedWrapperTest class methodsFor: 'testing' stamp: 'lr 4/7/2005 21:35'!
isAbstract
	^false! !

!MACheckedWrapperTest methodsFor: 'testing' stamp: 'lr 4/7/2005 23:13'!
testConflictCommit
	self value: self defaultElement.
	self assert: self wrapper original = self nullElement.
	self deny: self wrapper hasConflict.
	
	self value: self includedElement.
	self assert: self wrapper original = self nullElement.
	self assert: self wrapper hasConflict.
	
	self wrapper commit.
	self assert: self wrapper original = self defaultElement.
	self deny: self wrapper hasConflict.! !

!MACheckedWrapperTest methodsFor: 'testing' stamp: 'lr 4/7/2005 23:06'!
testConflictDefault
	self wrapper value: self includedElement.
	self assert: self wrapper original = self nullElement.
	self deny: self wrapper hasConflict.! !

!MACheckedWrapperTest methodsFor: 'testing' stamp: 'lr 4/7/2005 23:16'!
testConflictMerged
	self value: self includedElement.
	self wrapper value: self includedElement.
	self deny: self wrapper hasConflict.! !

!MACheckedWrapperTest methodsFor: 'private' stamp: 'lr 4/7/2005 23:01'!
wrapperInstance
	^MACheckedWrapper on: self description model: self.! !

!MAModelWrapperTest methodsFor: 'private' stamp: 'lr 3/30/2005 22:22'!
accessorInstance
	^MASelectorAccessor selector: #value.! !

!MAModelWrapperTest methodsFor: 'running' stamp: 'lr 3/30/2005 22:23'!
setUp
	super setUp.
	wrapper := self wrapperInstance.! !

!MAModelWrapperTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2005 22:25'!
testAccessor
	self assert: self wrapper accessor = self accessor.! !

!MAModelWrapperTest methodsFor: 'testing-accessing' stamp: 'lr 4/7/2005 22:54'!
testDefault
	self assert: self wrapper value = self defaultElement.! !

!MAModelWrapperTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2005 22:25'!
testDescription
	self assert: self wrapper description = self description.! !

!MAModelWrapperTest methodsFor: 'testing-errors' stamp: 'lr 4/7/2005 22:30'!
testErrorConcurrent
	self 
		should: [ self wrapper errorConcurrent ]
		raise: MAConcurrentError.
	[ self wrapper errorConcurrent ]
		on: MAConcurrentError
		do: [ :error |
			self assert: error accessor = self accessor.
			self assert: error wrapper = self wrapper.
			self assert: error description = self description ].! !

!MAModelWrapperTest methodsFor: 'testing-errors' stamp: 'lr 4/7/2005 22:30'!
testErrorReadonly
	self 
		should: [ self wrapper errorReadonly ]
		raise: MAReadonlyError.
	[ self wrapper errorReadonly ]
		on: MAReadonlyError
		do: [ :error |
			self assert: error accessor = self accessor.
			self assert: error wrapper = self wrapper.
			self assert: error description = self description ].! !

!MAModelWrapperTest methodsFor: 'testing-errors' stamp: 'lr 4/7/2005 22:29'!
testErrorRequired
	self 
		should: [ self wrapper errorRequired ]
		raise: MARequiredError.
	[ self wrapper errorRequired ]
		on: MARequiredError
		do: [ :error | 
			self assert: error accessor = self accessor.
			self assert: error wrapper = self wrapper.
			self assert: error description = self description ].! !

!MAModelWrapperTest methodsFor: 'testing-errors' stamp: 'lr 4/7/2005 22:30'!
testErrorValidation
	self 
		should: [ self wrapper errorValidation ]
		raise: MAValidationError.
	[ self wrapper errorValidation ]
		on: MAValidationError
		do: [ :error |			
			self assert: error accessor = self accessor.
			self assert: error wrapper = self wrapper.
			self assert: error description = self description ].! !

!MAModelWrapperTest methodsFor: 'testing-accessing' stamp: 'lr 3/30/2005 22:25'!
testModel
	self assert: self wrapper model = self.! !

!MAModelWrapperTest methodsFor: 'testing-primitives' stamp: 'lr 4/7/2005 22:55'!
testPull
	self value: self nullElement.
	self assert: self wrapper pull = self nullElement.
	
	self value: self invalidElement.
	self assert: self wrapper pull = self invalidElement.
	
	self value: self includedElement.
	self assert: self wrapper pull = self includedElement.! !

!MAModelWrapperTest methodsFor: 'testing-primitives' stamp: 'lr 4/7/2005 22:56'!
testPush
	self wrapper push: self nullElement.
	self assert: self value = self nullElement.
	
	self wrapper push: self invalidElement.
	self assert: self value = self invalidElement.
	
	self wrapper push: self includedElement.
	self assert: self value = self includedElement.! !

!MAModelWrapperTest methodsFor: 'testing-validation' stamp: 'lr 4/7/2005 22:56'!
testValidateIncluded
	self wrapper value: self invalidElement.
	self should: [ self wrapper validate ] raise: MAValidationError.
	
	self wrapper value: self includedElement.
	self shouldnt: [ self wrapper validate ] raise: MARequiredError.! !

!MAModelWrapperTest methodsFor: 'testing-validation' stamp: 'lr 4/7/2005 22:57'!
testValidateReadonly
	self description beReadonly; beRequired.
	
	self wrapper value: self nullElement.
	self shouldnt: [ self wrapper validate ] raise: MAReadonlyError.
	
	self wrapper value: self invalidElement.
	self shouldnt: [ self wrapper validate ] raise: MAReadonlyError.! !

!MAModelWrapperTest methodsFor: 'testing-validation' stamp: 'lr 4/7/2005 22:57'!
testValidateRequired
	self description beRequired.
	self wrapper value: self nullElement.
	self should: [ self wrapper validate ] raise: MARequiredError.
	
	self description beOptional.
	self wrapper value: self nullElement.
	self shouldnt: [ self wrapper validate ] raise: MARequiredError.! !

!MAModelWrapperTest methodsFor: 'accessing' stamp: 'lr 3/30/2005 22:22'!
wrapper
	^wrapper! !

!MAModelWrapperTest methodsFor: 'private' stamp: 'lr 3/30/2005 22:23'!
wrapperInstance
	^self subclassResponsibility! !

MAModelWrapperTest subclass: #MAStraitWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Accessor'!

!MAStraitWrapperTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:25'!
isAbstract
	^false! !

!MAStraitWrapperTest methodsFor: 'testing' stamp: 'lr 4/7/2005 22:54'!
testRead
	self assert: self wrapper value = self defaultElement.
	
	self value: '123'.
	self assert: self wrapper value = '123'.
	
	self value: '321'.
	self assert: self wrapper value = '321'.! !

!MAStraitWrapperTest methodsFor: 'testing-validation' stamp: 'lr 4/7/2005 22:57'!
testValidateRequired
	self description beRequired.
	self wrapper value: self nullElement.
	self shouldnt: [ self wrapper validate ] raise: MARequiredError.
	
	self description beOptional.
	self wrapper value: self nullElement.
	self shouldnt: [ self wrapper validate ] raise: MARequiredError.! !

!MAStraitWrapperTest methodsFor: 'testing' stamp: 'lr 4/7/2005 21:52'!
testWrite
	self wrapper value: '123'.
	self assert: self value = '123'.
	
	self wrapper value: '123'.
	self assert: self value = '123'.! !

!MAStraitWrapperTest methodsFor: 'private' stamp: 'lr 3/30/2005 22:24'!
wrapperInstance
	^MAStraitWrapper on: self description model: self.! !

TestCase subclass: #MAComparatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Comparator'!

!MAComparatorTest methodsFor: 'utilities' stamp: 'lr 3/19/2005 21:49'!
assert: aFirstObject and: aSecondObject satisfies: aSelector
	self assert: ((MAComparator perform: aSelector) 
		compare: aFirstObject 
		with: aSecondObject).! !

!MAComparatorTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:39'!
comparators
	^MAComparator classPool values.! !

!MAComparatorTest methodsFor: 'utilities' stamp: 'lr 3/19/2005 21:49'!
deny: aFirstObject and: aSecondObject satisfies: aSelector
	self deny: ((MAComparator perform: aSelector) 
		compare: aFirstObject 
		with: aSecondObject).! !

!MAComparatorTest methodsFor: 'testing-strings' stamp: 'lr 3/19/2005 21:48'!
testBeginsWith
	self assert: 'ab' and: 'a' satisfies: #beginsWith.
	self assert: 'ab' and: 'ab' satisfies: #beginsWith.
	
	self deny: 'ab' and: 'abc' satisfies: #beginsWith.
	self deny: 'ab' and: 'b' satisfies: #beginsWith.
	
	self deny: nil and: 'a' satisfies: #beginsWith.
	self deny: 'a' and: nil satisfies: #beginsWith. ! !

!MAComparatorTest methodsFor: 'testing-sorter' stamp: 'lr 3/24/2005 09:33'!
testBooleanSorter
	self assert: nil and: nil satisfies: #booleanSorter.
	self assert: nil and: false satisfies: #booleanSorter.
	self assert: nil and: true satisfies: #booleanSorter.
	
	self deny: false and: nil satisfies: #booleanSorter.
	self assert: false and: false satisfies: #booleanSorter.
	self assert: false and: true satisfies: #booleanSorter.
	
	self deny: true and: nil satisfies: #booleanSorter.
	self deny: true and: false satisfies: #booleanSorter.
	self assert: true and: true satisfies: #booleanSorter.! !

!MAComparatorTest methodsFor: 'testing-strings' stamp: 'lr 3/19/2005 21:48'!
testEndsWith
	self assert: 'ab' and: 'b' satisfies: #endsWith.
	self assert: 'ab' and: 'ab' satisfies: #endsWith.
	
	self deny: 'ab' and: 'abc' satisfies: #endsWith.
	self deny: 'ab' and: 'a' satisfies: #endsWith.
	
	self deny: nil and: 'a' satisfies: #endsWith.
	self deny: 'a' and: nil satisfies: #endsWith. ! !

!MAComparatorTest methodsFor: 'testing-equality' stamp: 'lr 3/19/2005 21:47'!
testEqualTo
	self assert: 1 and: 1 satisfies: #equalTo.
	self deny: 1 and: 2 satisfies: #equalTo.! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testGreaterThan
	self deny: 1 and: 2 satisfies: #greaterThan.
	self deny: 1 and: 1 satisfies: #greaterThan.
	self assert: 2 and: 1 satisfies: #greaterThan.
	
	self deny: 1 and: nil satisfies: #greaterThan.
	self deny: nil and: 1 satisfies: #greaterThan.
! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testGreaterThanOrEqualTo
	self deny: 1 and: 2 satisfies: #greaterThanOrEqualTo.
	self assert: 1 and: 1 satisfies: #greaterThanOrEqualTo.
	self assert: 2 and: 1 satisfies: #greaterThanOrEqualTo.

	self deny: 1 and: nil satisfies: #greaterThanOrEqualTo.
	self deny: nil and: 1 satisfies: #greaterThanOrEqualTo.! !

!MAComparatorTest methodsFor: 'testing' stamp: 'lr 3/17/2005 23:41'!
testLabel
	self comparators do: [ :each | 
		self deny: each asLabel isEmptyOrNil.
		self deny: each asLabel = each asString ].! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testLessThan
	self assert: 1 and: 2 satisfies: #lessThan.
	self deny: 1 and: 1 satisfies: #lessThan.
	self deny: 2 and: 1 satisfies: #lessThan.
	
	self deny: 1 and: nil satisfies: #lessThan.
	self deny: nil and: 1 satisfies: #lessThan.! !

!MAComparatorTest methodsFor: 'testing-magnitude' stamp: 'lr 3/19/2005 21:47'!
testLessThanOrEqualTo
	self assert: 1 and: 2 satisfies: #lessThanOrEqualTo.
	self assert: 1 and: 1 satisfies: #lessThanOrEqualTo.
	self deny: 2 and: 1 satisfies: #lessThanOrEqualTo.
	
	self deny: 1 and: nil satisfies: #lessThanOrEqualTo.
	self deny: nil and: 1 satisfies: #lessThanOrEqualTo.! !

!MAComparatorTest methodsFor: 'testing-sorter' stamp: 'lr 3/24/2005 09:50'!
testMagnitudeSorter
	self assert: nil and: nil satisfies: #magnitudeSorter.
	self assert: nil and: 0 satisfies: #magnitudeSorter.
	self assert: nil and: 1 satisfies: #magnitudeSorter.
	
	self deny: 0 and: nil satisfies: #magnitudeSorter.
	self assert: 0 and: 0 satisfies: #magnitudeSorter.
	self assert: 0 and: 1 satisfies: #magnitudeSorter.
	
	self deny: 1 and: nil satisfies: #magnitudeSorter.
	self deny: 1 and: 0 satisfies: #magnitudeSorter.
	self assert: 1 and: 1 satisfies: #magnitudeSorter.! !

!MAComparatorTest methodsFor: 'testing-strings' stamp: 'lr 3/19/2005 22:34'!
testMatch
	self assert: 'ab' and: '*' satisfies: #match.
	self assert: 'ab' and: '##' satisfies: #match.
	self assert: 'ab' and: '#b' satisfies: #match.
	self assert: 'ab' and: '*b' satisfies: #match.
	self assert: 'ab' and: 'a*b' satisfies: #match.
	self assert: 'ab' and: 'a#' satisfies: #match.
	self assert: 'ab' and: 'a*' satisfies: #match.
	self assert: 'ab' and: 'a' satisfies: #match.
	self assert: 'ab' and: 'b' satisfies: #match.
	
	self deny: 'ab' and: 'ba' satisfies: #match.
	self deny: 'ab' and: '?a' satisfies: #match.
	self deny: 'ab' and: 'b?' satisfies: #match.
	self deny: 'ab' and: '*a' satisfies: #match.
	self deny: 'ab' and: 'b*' satisfies: #match.

	self deny: nil and: 'a' satisfies: #match.
	self deny: 'a' and: nil satisfies: #match. ! !

!MAComparatorTest methodsFor: 'testing-equality' stamp: 'lr 3/19/2005 21:47'!
testNotEqualTo
	self deny: 1 and: 1 satisfies: #notEqualTo.
	self assert: 1 and: 2 satisfies: #notEqualTo.! !

!MAComparatorTest methodsFor: 'testing-sorter' stamp: 'lr 3/24/2005 09:51'!
testNullSorter
	self assert: nil and: nil satisfies: #nullSorter.
	self assert: nil and: 0 satisfies: #nullSorter.
	self assert: nil and: 1 satisfies: #nullSorter.
	
	self deny: 0 and: nil satisfies: #nullSorter.
	self assert: 0 and: 0 satisfies: #nullSorter.
	self assert: 0 and: 1 satisfies: #nullSorter.
	
	self deny: 1 and: nil satisfies: #nullSorter.
	self assert: 1 and: 0 satisfies: #nullSorter.
	self assert: 1 and: 1 satisfies: #nullSorter.! !

!MAComparatorTest methodsFor: 'testing-sorter' stamp: 'lr 3/24/2005 09:54'!
testStringSorter
	self assert: nil and: nil satisfies: #stringSorter.
	self assert: nil and: 'a' satisfies: #stringSorter.
	self assert: nil and: 'z' satisfies: #stringSorter.
	
	self deny: 'a' and: nil satisfies: #stringSorter.
	self assert: 'a' and: 'a' satisfies: #stringSorter.
	self assert: 'a' and: 'z' satisfies: #stringSorter.
	
	self deny: 'z' and: nil satisfies: #stringSorter.
	self deny: 'z' and: 'a' satisfies: #stringSorter.
	self assert: 'z' and: 'z' satisfies: #stringSorter.
	
	self assert: 'a' and: 'z' satisfies: #stringSorter.
	self assert: 'A' and: 'z' satisfies: #stringSorter.
	self assert: 'a' and: 'Z' satisfies: #stringSorter.
	self assert: 'A' and: 'Z' satisfies: #stringSorter.
	
	self deny: 'z' and: 'a' satisfies: #stringSorter.
	self deny: 'Z' and: 'a' satisfies: #stringSorter.
	self deny: 'z' and: 'A' satisfies: #stringSorter.
	self deny: 'Z' and: 'A' satisfies: #stringSorter.! !

TestCase subclass: #MADescriptionTest
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

MADescriptionTest subclass: #MAContainerTest
	instanceVariableNames: 'child1 child2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MAContainerTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MAContainerTest methodsFor: 'accessing' stamp: 'lr 3/27/2005 11:03'!
child1
	child1 isNil
		ifTrue: [ child1 := MAStringDescription selector: #child1 label: 'child1' priority: 1 ].
	^child1.! !

!MAContainerTest methodsFor: 'accessing' stamp: 'lr 3/27/2005 11:02'!
child2
	child2 isNil
		ifTrue: [ child2 := MAStringDescription selector: #child2 label: 'child2'  priority: 2 ].
	^child2.! !

!MAContainerTest methodsFor: 'private' stamp: 'lr 3/24/2005 00:06'!
descriptionClass
	^MAContainer! !

!MAContainerTest methodsFor: 'running' stamp: 'lr 3/27/2005 10:55'!
setUp
	super setUp.
	self description: self descriptionClass new.! !

!MAContainerTest methodsFor: 'testing-adding' stamp: 'lr 3/24/2005 10:05'!
testAdd
	self description add: self child1.
	self assert: (self description size = 1).
	self assert: (self description includes: self child1).
	
	self description add: self child2.
	self assert: (self description size = 2).
	self assert: (self description includes: self child1).
	self assert: (self description includes: self child2).
	
	! !

!MAContainerTest methodsFor: 'testing-adding' stamp: 'lr 3/24/2005 10:05'!
testAddAll
	self description addAll: (Array 
		with: self child1 
		with: self child2).
	
	self assert: (self description size = 2).
	self assert: (self description includes: self child1).
	self assert: (self description includes: self child2).
! !

!MAContainerTest methodsFor: 'testing-converting' stamp: 'lr 3/24/2005 12:13'!
testAsContainer
	self assert: self description asContainer = self description.! !

!MAContainerTest methodsFor: 'testing-accessing' stamp: 'lr 3/24/2005 10:02'!
testChildren
	self assert: self description children isCollection.
	self assert: self description children isEmpty.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 12:07'!
testCollect
	| collected |
	self description add: self child1; add: self child2.
	collected := self description collect: [ :each | each ].
	
	self assert: self description ~= collected.
	self assert: self description size = collected size.
	self assert: self description children first = description children first.
	self assert: self description children second = description children second.! !

!MAContainerTest methodsFor: 'testing-operators' stamp: 'lr 3/24/2005 12:26'!
testConcatenation
	| concatenate |
	concatenate := self description , self child1.
	self assert: concatenate size = 1.
	self assert: concatenate children first = self child1.
	
	concatenate := concatenate , self child2 asContainer.
	self assert: concatenate size = 2.
	self assert: concatenate children first = self child1.
	self assert: concatenate children second = self child2.! !

!MAContainerTest methodsFor: 'testing-copying' stamp: 'lr 3/24/2005 12:37'!
testCopy
	super testCopy.
	self description add: self child1; add: self child2.
	
	self deny: self description copy children == self description children.
	self assert: self description copy children first = self description children first.
	self assert: self description copy children second = self description children second.! !

!MAContainerTest methodsFor: 'testing-copying' stamp: 'lr 3/24/2005 12:10'!
testCopyFromTo
	| copied |
	self description add: self child1; add: self child2.
	copied := self description copyFrom: 1 to: 1.
	
	self assert: copied ~= self description.
	self assert: copied size = 1.
	self assert: copied children first = self description children first.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 10:45'!
testDetect
	self description add: self child1.
	self assert: (self description 
		detect: [ :each | self child1 = each ]) = self child1.
	self should: [ self description 
		detect: [ :each | self child2 = each ] ] raise: Error.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 10:45'!
testDetectIfNone
	self description add: self child1.
	self assert: (self description 
		detect: [ :each | self child1 = each ] 
		ifNone: [ 123 ]) = self child1.
	self assert: (self description 
		detect: [ :each | self child2 = each ] 
		ifNone: [ 123 ]) = 123.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 10:43'!
testDo
	| collection |
	collection := self description class defaultCollection.
	self description add: self child1; add: self child2.
	self description do: [ :each | collection add: each ].
	self assert: (self description children hasEqualElements: collection).! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 10:45'!
testDoSepratedBy
	| collection |
	collection := OrderedCollection new.
	self description add: self child1; add: self child2.
	self description 
		do: [ :each | collection add: each ]
		separatedBy: [ collection add: nil ].
	self assert: collection size = 3.
	self assert: collection first = self child1.
	self assert: collection second isNil.
	self assert: collection third = self child2.! !

!MAContainerTest methodsFor: 'testing-testing' stamp: 'lr 3/24/2005 10:09'!
testEmpty
	self assert: self description isEmpty.
	self description add: self child1.
	self deny: self description isEmpty.! !

!MAContainerTest methodsFor: 'testing-testing' stamp: 'lr 4/6/2005 20:56'!
testHasChildren
	super testHasChildren.
	self description add: self child1.
	self assert: self description hasChildren.! !

!MAContainerTest methodsFor: 'testing-testing' stamp: 'lr 3/24/2005 10:08'!
testIncludes
	self deny: (self description includes: self child1).
	self description add: self child1.
	self assert: (self description includes: self child1).! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/27/2005 11:00'!
testInjectInto
	self description add: self child1; add: self child2.
	self assert: (self description 
		inject: 'start'
		into: [ :result :each | result , ' ' , each label ]) = 'start child1 child2'.! !

!MAContainerTest methodsFor: 'testing-testing' stamp: 'lr 4/6/2005 20:57'!
testIsContainer
	self assert: self description isContainer.! !

!MAContainerTest methodsFor: 'testing-moving' stamp: 'lr 3/24/2005 10:12'!
testMoveDown
	self description add: self child1; add: self child2.
	self assert: self description children first = self child1.
	self assert: self description children second = self child2.
	
	self description moveDown: self child1.
	self assert: self description children first = self child2.
	self assert: self description children second = self child1.
	
	self description moveDown: self child1.
	self assert: self description children first = self child1.
	self assert: self description children second = self child2.
	! !

!MAContainerTest methodsFor: 'testing-moving' stamp: 'lr 3/24/2005 10:11'!
testMoveUp
	self description add: self child1; add: self child2.
	self assert: self description children first = self child1.
	self assert: self description children second = self child2.
	
	self description moveUp: self child2.
	self assert: self description children first = self child2.
	self assert: self description children second = self child1.
	
	self description moveUp: self child2.
	self assert: self description children first = self child1.
	self assert: self description children second = self child2.
	! !

!MAContainerTest methodsFor: 'testing-testing' stamp: 'lr 3/24/2005 10:09'!
testNotEmpty
	self deny: self description notEmpty.
	self description add: self child1.
	self assert: self description notEmpty.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 12:11'!
testReject
	| rejected |
	self description add: self child1; add: self child2.
	rejected := self description reject: [ :each | false ].
	
	self assert: self description ~= rejected.
	self assert: self description size = rejected size.
	self assert: self description children first = rejected children first.
	self assert: self description children second = rejected children second.! !

!MAContainerTest methodsFor: 'testing-removing' stamp: 'lr 3/24/2005 10:07'!
testRemove
	self description add: self child1; add: self child2.

	self description remove: self child1.
	self assert: self description size = 1.
	self deny: (self description includes: self child1).
	self assert: (self description includes: self child2).

	self description remove: self child2.
	self assert: self description isEmpty.! !

!MAContainerTest methodsFor: 'testing-removing' stamp: 'lr 3/24/2005 10:07'!
testRemoveAll
	self description add: self child1; add: self child2.

	self description removeAll.
	self assert: self description isEmpty.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 3/24/2005 12:11'!
testSelect
	| selected |
	self description add: self child1; add: self child2.
	selected := self description select: [ :each | true ].
	
	self assert: self description ~= selected.
	self assert: self description size = selected size.
	self assert: self description children first = selected children first.
	self assert: self description children second = selected children second.! !

!MAContainerTest methodsFor: 'testing-accessing' stamp: 'lr 3/24/2005 10:03'!
testSize
	self assert: self description size isZero.
	self description add: self child1.
	self assert: self description size = 1.
	self description add: self child2.
	self assert: self description size = 2.! !

!MAContainerTest methodsFor: 'testing-enumerating' stamp: 'lr 4/6/2005 21:25'!
testWithIndexDo
	self description add: self child1; add: self child2.
	self description withIndexDo: [ :each :index | 
		index = 1
			ifTrue: [ self assert: self child1 = each ]
			ifFalse: [
				index = 2
					ifTrue: [ self assert: self child2 = each ]
					ifFalse: [ self assert: false ] ] ].! !

MAContainerTest subclass: #MAPriorityContainerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MAPriorityContainerTest methodsFor: 'private' stamp: 'lr 3/24/2005 10:14'!
descriptionClass
	^MAPriorityContainer! !

!MAPriorityContainerTest methodsFor: 'testing-moving' stamp: 'lr 4/6/2005 22:19'!
testMoveDown
	self description add: self child1; add: self child2.
	self assert: self description children first = self child1.
	self assert: self description children second = self child2.
	self assert: self child2 priority = 2.
	
	self description moveDown: self child2; moveDown: self child2.
	self assert: self description children first = self child2.
	self assert: self description children second = self child1.
	self assert: self child2 priority = 0.! !

!MAPriorityContainerTest methodsFor: 'testing-moving' stamp: 'lr 4/6/2005 22:13'!
testMoveUp
	self description add: self child1; add: self child2.
	self assert: self description children first = self child1.
	self assert: self description children second = self child2.
	self assert: self child1 priority = 1.
	
	self description moveUp: self child1; moveUp: self child1.
	self assert: self description children first = self child2.
	self assert: self description children second = self child1.
	self assert: self child1 priority = 3.! !

MAContainerTest subclass: #MAReportContainerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MAReportContainerTest methodsFor: 'private' stamp: 'lr 3/24/2005 10:14'!
descriptionClass
	^MAReportContainer! !

!MADescriptionTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:33'!
isAbstract
	^true! !

!MADescriptionTest class methodsFor: 'testing' stamp: 'lr 3/11/2005 22:47'!
shouldInheritSelectors
	^true! !

!MADescriptionTest methodsFor: 'accessing' stamp: 'lr 3/14/2005 10:44'!
description
	^description! !

!MADescriptionTest methodsFor: 'accessing' stamp: 'lr 3/14/2005 10:44'!
description: anObject
	description := anObject! !

!MADescriptionTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:05'!
descriptionClass
	self subclassResponsibility! !

!MADescriptionTest methodsFor: 'testing-accessing' stamp: 'lr 4/6/2005 22:59'!
testAccessor
	self assert: self description accessor description = self description.! !

!MADescriptionTest methodsFor: 'testing-converting' stamp: 'lr 4/6/2005 21:06'!
testAsContainer
	self subclassResponsability.! !

!MADescriptionTest methodsFor: 'testing-converting' stamp: 'lr 4/6/2005 21:05'!
testAsLabel
	self assert: self description asLabel = self description asString.
	
	self description label: 'foo'.
	self assert: self description asLabel = 'foo'.! !

!MADescriptionTest methodsFor: 'testing-accessing' stamp: 'lr 3/27/2005 11:09'!
testComment
	description comment: 'bar'.
	self assert: description comment = 'bar'.! !

!MADescriptionTest methodsFor: 'testing-copying' stamp: 'lr 3/28/2005 19:29'!
testCopy
	| copy |
	copy := self description copy.
		
	self deny: self description = copy.
	self deny: self description properties == copy properties.
	
	self assert: self description properties = copy properties.
	self assert: self description properties size = copy properties size.
		
	self assert: self description label = copy label.
	self assert: self description comment = copy comment.
	self assert: self description priority = copy priority.
	
	self assert: self description persistent = copy persistent.
	self assert: self description readonly = copy readonly.
	self assert: self description required = copy required.
	self assert: self description visible = copy visible.! !

!MADescriptionTest methodsFor: 'testing-other' stamp: 'lr 4/6/2005 19:01'!
testDictionary
	| dictionary |
	dictionary := Dictionary new.
	
	dictionary at: self description put: 1.
	self assert: (dictionary at: self description) = 1.
	
	dictionary at: self description copy put: 2.
	self assert: (dictionary at: self description) = 1.
	
	dictionary at: self description put: 3.
	self assert: (dictionary at: self description) = 3.! !

!MADescriptionTest methodsFor: 'testing-comparing' stamp: 'lr 4/6/2005 14:17'!
testEqual
	self assert: self description = self description.
	self deny: self description = self description copy.! !

!MADescriptionTest methodsFor: 'testing-testing' stamp: 'lr 4/6/2005 20:55'!
testHasChildren
	self deny: self description hasChildren.! !

!MADescriptionTest methodsFor: 'testing-testing' stamp: 'lr 3/27/2005 12:00'!
testHasComment
	self description comment: nil.
	self deny: self description hasComment.
	
	self description comment: ''.
	self deny: self description hasComment.
	
	self description comment: 'comment'.
	self assert:  self description hasComment.! !

!MADescriptionTest methodsFor: 'testing-testing' stamp: 'lr 3/27/2005 12:00'!
testHasLabel
	self description label: nil.
	self deny: self description hasLabel.
	
	self description label: ''.
	self deny: self description hasLabel.
	
	self description label: 'label'.
	self assert:  self description hasLabel.! !

!MADescriptionTest methodsFor: 'testing-comparing' stamp: 'lr 4/6/2005 21:07'!
testHash
	self assert: self description hash isInteger.
	self assert: self description hash = self description hash.
	self deny: self description hash = self description copy hash.! !

!MADescriptionTest methodsFor: 'testing-testing' stamp: 'lr 4/6/2005 20:57'!
testIsContainer
	self deny: self description isContainer.! !

!MADescriptionTest methodsFor: 'testing-accessing' stamp: 'lr 3/27/2005 11:08'!
testLabel
	self description label: 'foo'.
	self assert: self description label = 'foo'.! !

!MADescriptionTest methodsFor: 'testing-other' stamp: 'lr 4/6/2005 21:07'!
testPersistency
	| output input object |
	
	" every description should be serializeable "
	output := ReferenceStream on: (RWBinaryOrTextStream on: ByteArray new).
	output nextPut: self description.
	output close.
	
	" read back the serialized description "
	input := ReferenceStream on: output contents readStream.
	object := input next.
	
	" different object reference, but equal object "
	self assert: self description = object.
	self deny: self description == object.! !

!MADescriptionTest methodsFor: 'testing-actions' stamp: 'lr 4/6/2005 21:09'!
testPersistent
	self description beEphemeral.
	self deny: self description persistent.
	self deny: self description isPersistent.
	
	self description bePersistent.
	self assert: self description persistent.
	self assert: self description isPersistent.! !

!MADescriptionTest methodsFor: 'testing-accessing' stamp: 'lr 3/27/2005 11:09'!
testPriority
	description priority: 123.
	self assert: description priority = 123.! !

!MADescriptionTest methodsFor: 'testing-properties' stamp: 'lr 4/6/2005 21:13'!
testPropertiesAt
	self description propertyAt: #foo put: 'bar'.
	
	self assert: (self description propertyAt: #foo) = 'bar'.
	self should: [ self description propertyAt: #bar ] raise: Error.! !

!MADescriptionTest methodsFor: 'testing-properties' stamp: 'lr 4/6/2005 21:13'!
testPropertiesAtIfAbsent
	self description propertyAt: #foo put: 'bar'.
	
	self assert: (self description propertyAt: #foo ifAbsent: [ 'baz' ]) = 'bar'.
	self assert: (self description propertyAt: #bar ifAbsent: [ 'baz' ]) = 'baz'.
	! !

!MADescriptionTest methodsFor: 'testing-properties' stamp: 'lr 4/6/2005 21:14'!
testPropertiesAtIfAbsentPut
	self assert: (self description propertyAt: #foo ifAbsentPut: [ 'bar' ]) = 'bar'.
	self assert: (self description propertyAt: #foo ifAbsentPut: [ 'baz' ]) = 'bar'.! !

!MADescriptionTest methodsFor: 'testing-properties' stamp: 'lr 4/6/2005 21:13'!
testPropertiesIncludes
	self description propertyAt: #foo put: 'bar'.
	
	self assert: (self description propertyIncludes: #foo).
	self deny: (self description propertyIncludes: #bar).! !

!MADescriptionTest methodsFor: 'testing-actions' stamp: 'lr 4/6/2005 21:12'!
testReadonly
	self description beReadonly.
	self assert: self description readonly.
	self assert: self description isReadonly.
	
	self description beWriteable.
	self deny: self description readonly.
	self deny: self description isReadonly.! !

!MADescriptionTest methodsFor: 'testing-actions' stamp: 'lr 4/6/2005 21:11'!
testRequired
	self description beRequired.
	self assert: self description required.
	self assert: self description isRequired.
	
	self description beOptional.
	self deny: self description required.
	self deny: self description isRequired.
! !

!MADescriptionTest methodsFor: 'testing-other' stamp: 'lr 4/6/2005 19:23'!
testSet
	| set |
	set := Set new.
	
	set add: self description.
	self assert: set size = 1.
	self assert: (set includes: self description).

	set add: self description.
	self assert: set size = 1.
	self assert: (set includes: self description).
			
	set add: self description copy.
	self assert: set size = 2.
	self assert: (set includes: self description).! !

!MADescriptionTest methodsFor: 'testing-actions' stamp: 'lr 4/6/2005 21:09'!
testVisible
	self description beHidden.
	self deny: self description visible.
	self deny: self description isVisible.
	
	self description beVisible.
	self assert: self description visible.
	self assert: self description isVisible.
! !

MADescriptionTest subclass: #MAElementTest
	instanceVariableNames: 'value wrapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

MAElementTest subclass: #MABinaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MABinaryTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MABinaryTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MABinaryDescription! !

!MABinaryTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^ByteArray with: 1 with: 2 with: 3.! !

MAElementTest subclass: #MABooleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MABooleanTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MABooleanTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:11'!
descriptionClass
	^MABooleanDescription! !

!MABooleanTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^true! !

!MAElementTest methodsFor: 'private' stamp: 'lr 3/21/2005 20:04'!
includedElement
	self subclassResponsibility! !

!MAElementTest methodsFor: 'private' stamp: 'lr 3/21/2005 20:04'!
invalidElement
	^Object new! !

!MAElementTest methodsFor: 'private' stamp: 'lr 3/21/2005 20:04'!
nullElement
	^nil! !

!MAElementTest methodsFor: 'private' stamp: 'lr 3/21/2005 20:04'!
nullString
	^String new! !

!MAElementTest methodsFor: 'running' stamp: 'lr 4/5/2005 21:17'!
setUp
	super setUp.
	description := self descriptionClass 
		selector: #value.
	wrapper := MAStraitWrapper 
		on: self description 
		model: self.! !

!MAElementTest methodsFor: 'testing' stamp: 'lr 4/6/2005 22:47'!
testAcceessor
	super testAccessor.
	self assert: self description accessor selector = #value.! !

!MAElementTest methodsFor: 'testing-converting' stamp: 'lr 3/24/2005 12:20'!
testAsContainer
	self assert: self description asContainer size = 1.
	self assert: (self description asContainer includes: self description).! !

!MAElementTest methodsFor: 'testing-converting' stamp: 'lr 3/24/2005 12:35'!
testConcatenation
	| child1 child2 concatenate |
	child1 := self description copy.
	child2 := self description copy.
	
	concatenate := child1 , child2.
	self assert: concatenate size = 2.
	self assert: concatenate children first = child1.
	self assert: concatenate children second = child2.
	
	concatenate := child1 , concatenate.
	self assert: concatenate size = 3.
	self assert: concatenate children first = child1.
	self assert: concatenate children second = child1.
	self assert: concatenate children third = child2.! !

!MAElementTest methodsFor: 'testing-copying' stamp: 'lr 3/27/2005 12:08'!
testCopy
	super testCopy.
	self description copy in: [ :copy |
		self deny: copy accessor == self description accessor.
		self assert: copy default =  self description default.
		self assert: copy accessor description == copy ].! !

!MAElementTest methodsFor: 'testing' stamp: 'lr 3/14/2005 10:42'!
testDefault
	description default: #foo.
	self assert: description default = #foo.
	
	! !

!MAElementTest methodsFor: 'testing-testing' stamp: 'lr 3/14/2005 11:12'!
testIncludes
	self assert: (self description includes: self includedElement).
	self deny: (self description includes: self invalidElement).
	self deny: (self description includes: self nullElement).! !

!MAElementTest methodsFor: 'testing' stamp: 'lr 3/23/2005 14:18'!
testKind
	self assert: (self includedElement isKindOf: self description kind).! !

!MAElementTest methodsFor: 'testing-converting' stamp: 'lr 3/27/2005 10:53'!
testMigrate
	| result |
	result := (MAStringDescription selector: #value)
		migrate: self includedElement
		from: self description.
	self assert: (self description 
		toString: self includedElement) = result.! !

!MAElementTest methodsFor: 'testing-converting' stamp: 'lr 3/29/2005 21:01'!
testParseString
	self assert: (self description parseString: self nullElement) isNil.
	self assert: (self description parseString: self nullString) isNil.
	self assert: (self description includes: (description 
		parseString: (self description toString: self includedElement))).
	! !

!MAElementTest methodsFor: 'testing-model' stamp: 'lr 4/8/2005 00:12'!
testRead
	| other |
	self value: (other := self includedElement).
	self assert: self wrapper value = other.
	
	self value: (other := self nullElement).
	self assert: self wrapper value = self descriptionClass defaultDefault.! !

!MAElementTest methodsFor: 'testing-converting' stamp: 'lr 3/21/2005 20:14'!
testToString
	self assert: (self description toString: self includedElement) = self includedElement asLabel.
	self assert: (self description toString: self nullElement) = String new.! !

!MAElementTest methodsFor: 'testing-testing' stamp: 'lr 4/6/2005 23:12'!
testValidates
	self shouldnt: [ self wrapper validate: self includedElement ] raise: MAError.
	self shouldnt: [ self wrapper validate: self nullElement ] raise: MAError.
	self should: [ self wrapper validate: self invalidElement ] raise: MAError.
	! !

!MAElementTest methodsFor: 'testing-model' stamp: 'lr 3/30/2005 23:00'!
testWrite
	| other |
	self wrapper value: (other := self includedElement).
	self assert: self value = other.! !

!MAElementTest methodsFor: 'testing-model' stamp: 'lr 4/8/2005 00:09'!
testWriteIncluded
	self wrapper value: self invalidElement.
	self
		should: [ self wrapper validate; commit  ]
		raise: MAValidationError.
		
	self wrapper value: self nullElement.
	self
		shouldnt: [ self wrapper validate; commit ]
		raise: MAValidationError.
	
	self wrapper value: self includedElement.
	self
		shouldnt: [ self wrapper validate; commit ]
		raise: MAValidationError.! !

!MAElementTest methodsFor: 'testing-model' stamp: 'lr 4/5/2005 21:07'!
testWriteReadonly
	self value: self includedElement.
	self description beReadonly.
	self
		should: [ self wrapper commit ]
		raise: MAReadonlyError.

	self value: self includedElement.
	self description beWriteable.
	self
		shouldnt: [ self wrapper commit ]
		raise: MAReadonlyError.! !

!MAElementTest methodsFor: 'testing-model' stamp: 'lr 4/8/2005 00:10'!
testWriteRequired
	self description beRequired.
	self value: self nullElement.
	self
		should: [ self wrapper validate; commit ]
		raise: MARequiredError.
	self value: self includedElement.
	self
		shouldnt: [ self wrapper validate; commit ]
		raise: MARequiredError.
		
	self description beOptional.
	self value: self nullElement.
	self
		shouldnt: [ self wrapper validate; commit ]
		raise: MARequiredError.
	self value: self includedElement.
	self
		shouldnt: [ self wrapper validate; commit ]
		raise: MARequiredError.! !

!MAElementTest methodsFor: 'accessing' stamp: 'lr 3/21/2005 20:03'!
value
	^value! !

!MAElementTest methodsFor: 'accessing' stamp: 'lr 3/21/2005 20:03'!
value: anObject
	value := anObject! !

!MAElementTest methodsFor: 'accessing' stamp: 'lr 3/30/2005 22:59'!
wrapper
	^wrapper! !

MAElementTest subclass: #MAMagnitudeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

MAMagnitudeTest subclass: #MADateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MADateTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MADateTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:11'!
descriptionClass
	^MADateDescription! !

!MADateTest methodsFor: 'private' stamp: 'lr 3/20/2005 09:28'!
includedElement
	^Date newDay: 1 month: 2 year: 3456.! !

MAMagnitudeTest subclass: #MADurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MADurationTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MADurationTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:03'!
descriptionClass
	^MADurationDescription! !

!MADurationTest methodsFor: 'private' stamp: 'lr 3/17/2005 23:04'!
includedElement
	^Duration days: 1 hours: 2 minutes: 3 seconds: 4.! !

MAMagnitudeTest subclass: #MANumberTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MANumberTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MANumberTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:12'!
descriptionClass
	^MANumberDescription! !

!MANumberTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^123! !

MAMagnitudeTest subclass: #MATimeStampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MATimeStampTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:35'!
isAbstract
	^false! !

!MATimeStampTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MATimeStampDescription! !

!MATimeStampTest methodsFor: 'private' stamp: 'lr 3/20/2005 09:29'!
includedElement
	^TimeStamp year: 1 month: 2 day: 3456 hour: 7 minute: 8.! !

MAMagnitudeTest subclass: #MATimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MATimeTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:35'!
isAbstract
	^false! !

!MATimeTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MATimeDescription! !

!MATimeTest methodsFor: 'private' stamp: 'lr 3/20/2005 09:28'!
includedElement
	^Time hour: 1 minute: 2 second: 3.! !

MAElementTest subclass: #MAOptionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MAOptionsTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MAOptionsTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:10'!
descriptionClass
	^MAOptionsDescription! !

!MAOptionsTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:28'!
includedElement
	^'Option 1'! !

!MAOptionsTest methodsFor: 'running' stamp: 'lr 3/29/2005 20:37'!
setUp
	super setUp.
	self description options 
		add: 'Option 1'; 
		add: 'Option 2'; 
		add: 'Option 3'.! !

!MAOptionsTest methodsFor: 'testing-copying' stamp: 'lr 3/29/2005 20:37'!
testCopy
	super testCopy.
	self description copy in: [ :copy |
		self deny: copy options == self description options.
		self assert: copy options = self description options ].! !

!MAOptionsTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:32'!
testNone
	self description none: 'none'.
	self assert: self description none = 'none'.! !

!MAOptionsTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:32'!
testOptions
	self description options: #( a b c ).
	self assert: self description options = #( a b c ).! !

!MAOptionsTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:35'!
testOptionsTextual
	self description options: #( 'a' 'b' ).
	self assert: self description optionsTextual = 'a
b'.

	self description optionsTextual: 'x
y'.
	self assert: self description options asArray = #( 'x' 'y' ).! !

MAElementTest subclass: #MAStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

MAStringTest subclass: #MAPasswordTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MAPasswordTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:08'!
descriptionClass
	^MAPasswordDescription! !

!MAStringTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:34'!
isAbstract
	^false! !

!MAStringTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:08'!
descriptionClass
	^MAStringDescription! !

!MAStringTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:29'!
includedElement
	^'Hello World'! !

MAStringTest subclass: #MASymbolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MASymbolTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:09'!
descriptionClass
	^MASymbolDescription! !

!MASymbolTest methodsFor: 'private' stamp: 'lr 3/14/2005 10:29'!
includedElement
	^#foo! !

MAStringTest subclass: #MATextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MATextTest methodsFor: 'private' stamp: 'lr 3/17/2005 15:09'!
descriptionClass
	^MATextDescription! !

MAElementTest subclass: #MATableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Description'!

!MATableTest class methodsFor: 'testing' stamp: 'lr 3/30/2005 22:35'!
isAbstract
	^false! !

!MATableTest methodsFor: 'private' stamp: 'lr 3/29/2005 20:47'!
descriptionClass
	^MATableDescription! !

!MATableTest methodsFor: 'private' stamp: 'lr 3/29/2005 20:51'!
includedElement
	^ #( 'a1' 'a2' 'b1' 'b2' 'c1' 'c2' )! !

!MATableTest methodsFor: 'private' stamp: 'lr 3/29/2005 20:56'!
invalidElement
	^ #( 'a' 'b' 'c' 'd' 'e' )! !

!MATableTest methodsFor: 'running' stamp: 'lr 3/29/2005 20:51'!
setUp
	super setUp.
	self description 
		columnLabels: #( a b );
		rowLabels: #( x y z ).! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 21:00'!
testCellCount
	self assert: self description cellCount = 6.! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:54'!
testCellDescription
	| other |
	self description cellDescription: (other := MANumberDescription new).
	self assert: self description cellDescription = other.! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:50'!
testColumnCount
	self assert: self description columnCount = 2.! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:53'!
testColumnLabels
	self description columnLabels: #( '1' '2' ).
	self assert: self description columnLabels = #( '1' '2' ).! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:55'!
testColumnLabelsTextual
	self description columnLabels: #( '1' '2' ).
	self assert: self description columnLabelsTextual = '1
2'.

	self description columnLabelsTextual: '2
1'.
	self assert: self description columnLabels asArray = #( '2' '1' ).! !

!MATableTest methodsFor: 'testing-copying' stamp: 'lr 3/29/2005 20:52'!
testCopy
	super testCopy.
	self description copy in: [ :copy |
		self deny: copy rowLabels == self description rowLabels.
		self assert: copy rowLabels = self description rowLabels.
		self deny: copy columnLabels == self description columnLabels.
		self assert: copy columnLabels = self description columnLabels.
		self deny: copy cellDescription == self description cellDescription ].! !

!MATableTest methodsFor: 'testing-converting' stamp: 'lr 3/29/2005 21:02'!
testParseString
	" doesn't make much sense "! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:51'!
testRowCount
	self assert: self description rowCount = 3.! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:53'!
testRowLabels
	self description rowLabels: #( '1' '2' ).
	self assert: self description rowLabels = #( '1' '2' ).! !

!MATableTest methodsFor: 'testing-accessing' stamp: 'lr 3/29/2005 20:55'!
testRowLabelsTextual
	self description rowLabels: #( '1' '2' ).
	self assert: self description rowLabelsTextual = '1
2'.

	self description rowLabelsTextual: '2
1'.
	self assert: self description rowLabels asArray = #( '2' '1' ).! !

TestCase subclass: #MADynamicObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tests-Utility'!

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/21/2005 20:10'!
testCalculated
	| object dummy |
	object := MADynamicObject on: [ Time millisecondClockValue ].
	dummy := object yourself.
	
	(Delay forMilliseconds: 2) wait.
	self assert: dummy < object.! !

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/19/2005 20:35'!
testCollection
	| object |
	object := MADynamicObject on: [ OrderedCollection with: 1 with: 2 ].
	self assert: object size = 2.
	self assert: object first = 1.
	self assert: object second = 2.
	
	object add: 3.
	self assert: object size = 2.
	self assert: object first = 1.
	self assert: object second = 2.! !

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/19/2005 20:35'!
testConstant
	| object |
	object := MADynamicObject on: [ self ].
	self assert: object = self.
	
	object := MADynamicObject on: [ 123 ].
	self assert: object = 123.! !

!MADynamicObjectTest methodsFor: 'testing' stamp: 'lr 3/19/2005 20:36'!
testNil
	| object |
	object := MADynamicObject on: 'abc'.
	self deny: object isNil.
	self assert: object notNil.
	
	object := MADynamicObject on: nil.
	self assert: object isNil.
	self deny: object notNil.! !
